﻿using System;
using Infragistics.Win.UltraWinProgressBar;
using System.Drawing;
using Infragistics.Win;

namespace WindowsFormsApplication15
{
    public class NullableProgressBar : System.Windows.Forms.UserControl
    {

        #region "Properties"
        public UltraProgressBar Base
        {
            get { return BaseControl; }
        }

        public Nullable<int> Value
        {
            get { return Base.Value; }
            set
            {
                if (value.HasValue)
                {
                    if (value > Base.Maximum)
                    {
                        Base.Value = Base.Maximum;
                    }
                    else
                    {
                        Base.Value = value.Value;
                    }
                    Base.Text = string.Concat(value.Value, "%");
                    Base.Visible = true;
                }
                else
                {
                    Base.Value = 0;
                    Base.Visible = false;
                }
            }
        }

        public override Color BackColor
        {
            get { return base.BackColor; }
            set
            {
                base.BackColor = value;
                Base.BackColor = value;
                Base.Appearance.BackColor = value;
            }
        }
        #endregion

        public NullableProgressBar()
        {
            InitializeComponent();
            ProgressBarSettings();
        }

        private void ProgressBarSettings()
        {
            Base.Minimum = 0;
            Base.Maximum = 100;
            Base.Appearance.TextHAlign = HAlign.Left;
            Base.Appearance.TextVAlign = VAlign.Middle;
            Base.BorderStyle = UIElementBorderStyle.None;
        }

        //UserControl overrides dispose to clean up the component list.
        [System.Diagnostics.DebuggerNonUserCode()]
        protected override void Dispose(bool disposing)
        {
            try
            {
                if (disposing && components != null)
                {
                    components.Dispose();
                }
            }
            finally
            {
                base.Dispose(disposing);
            }
        }

        //Required by the Windows Form Designer

        private System.ComponentModel.IContainer components;
        //NOTE: The following procedure is required by the Windows Form Designer
        //It can be modified using the Windows Form Designer.  
        //Do not modify it using the code editor.
        [System.Diagnostics.DebuggerStepThrough()]
        private void InitializeComponent()
        {
            this.BaseControl = new UltraProgressBar();
            this.SuspendLayout();
            //
            //BaseControl
            //
            this.BaseControl.Anchor = (System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) | System.Windows.Forms.AnchorStyles.Left) | System.Windows.Forms.AnchorStyles.Right);
            this.BaseControl.Location = new System.Drawing.Point(2, 2);
            this.BaseControl.Name = "BaseControl";
            this.BaseControl.Size = new System.Drawing.Size(40, 13);
            this.BaseControl.TabIndex = 0;
            this.BaseControl.Text = "[Formatted]";
            //
            //JdnProgressBar
            //
            this.AutoScaleDimensions = new System.Drawing.SizeF(6f, 13f);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.Controls.Add(this.BaseControl);
            this.Name = "NullableProgressBar";
            this.Size = new System.Drawing.Size(42, 15);
            this.ResumeLayout(false);

        }
        internal UltraProgressBar BaseControl;
    }

}
